Last Comment Bug 709477 - random bolder words appear after scrolling on whatsup.co.il
: random bolder words appear after scrolling on whatsup.co.il
Status: RESOLVED FIXED
: regression
Product: Core
Classification: Components
Component: Graphics (show other bugs)
: 10 Branch
: x86 Linux
: -- normal with 3 votes (vote)
: mozilla17
Assigned To: Karl Tomlinson (:karlt)
:
Mentors:
http://whatsup.org.il/index.php?name=...
: 775203 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-12-10 08:12 PST by Tomer Cohen :tomer
Modified: 2015-03-10 07:14 PDT (History)
16 users (show)
karlt: in‑testsuite+
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
Screenshot - Please note the bolder text. (160.37 KB, image/png)
2011-12-10 08:12 PST, Tomer Cohen :tomer
no flags Details
partially simplified testcase (6.04 KB, text/html; charset=WINDOWS-1255)
2012-02-24 15:46 PST, David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch)
no flags Details
more reduced testcase (1.99 KB, text/html)
2012-02-24 20:19 PST, Timothy Nikkel (:tnikkel)
no flags Details
WordPress RTL screenshot (26.30 KB, image/png)
2012-03-01 00:43 PST, Tomer Cohen :tomer
no flags Details
another site screenshot (82.60 KB, image/png)
2012-03-24 10:53 PDT, Tomer Cohen :tomer
no flags Details
use precise region extents instead of loose clip extents for clip rect (4.45 KB, patch)
2012-07-30 16:16 PDT, Karl Tomlinson (:karlt)
jmuizelaar: review+
Details | Diff | Splinter Review
reftest (3.90 KB, patch)
2012-07-31 18:59 PDT, Karl Tomlinson (:karlt)
no flags Details | Diff | Splinter Review

Description Tomer Cohen :tomer 2011-12-10 08:12:59 PST
Created attachment 580649 [details]
Screenshot - Please note the bolder text.

Sometimes, after using the mouse scroller, some text on this site appears bolder than other words, while probably nothing was changed. 

I'm using Ubuntu on a Dell Inspiron 1525 laptop, and have this issue for a long time. It might be something with the display adapter, but it happens only using Firefox.

Steps to reproduce:
a. Enter the site and navigate to a random topic on the forum. (The following one is a good example: http://whatsup.org.il/index.php?name=PNphpBB2&file=viewtopic&t=57990)
b. Scroll up and down using the mouse wheel, for the weird effect to happen.


Screenshot attached. (Rendered with an Aurora build)


Meir, the webmaster of this site is CC'ed to this issue. Meir, do you know if some other users have similar complains?
Comment 1 Meir Kriheli 2011-12-11 02:02:24 PST
No one complained, but I have those issues as well for quite some time (FF 8.0.1 on ArchLinux).
Comment 2 Tomer Cohen :tomer 2011-12-11 06:24:28 PST
Seems that this issue is very similar to the behavior described here: https://support.mozilla.com/en-US/kb/Some%20text%20shows%20up%20bold%20after%20upgrade

Maybe it could be solved by changing fonts, but it should not happen in multiple [clean] profiles!
Comment 3 Tomer Cohen :tomer 2012-02-24 13:56:49 PST
See also: http://whatsup.org.il/index.php?name=PNphpBB2&file=viewtopic&t=58460
Comment 4 Jonathan Kew (:jfkthame) 2012-02-24 14:29:04 PST
A couple of observations, in case they help anyone figure out what could be going wrong:

- The bad rendering does not necessarily start at a word boundary, or even between characters; it begins at some arbitrary place along the line, possibly even in the middle of a glyph. I think this suggests a graphics-level rather than layout/text-level issue.

- It always seems to end, however, when it reaches a transition between Hebrew and English (or vice versa) - i.e. a direction-run boundary - although it _may_ also end even where there isn't such a boundary. This could hint at a layout/text issue rather than graphics. Hmmm....

- The "bolder" text looks like it has been painted multiple times, judging by the intense color (antialiasing) fringes on the glyphs; that would be the result of partially-transparent pixels being repainted several times without erasing.
Comment 5 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2012-02-24 15:23:57 PST
I see this with scrollbar scrolling as well, on Ubuntu 11.10, on the URL in comment 0.  (I don't have a working mousewheel.)

The right edge (the straight line edge) of where the problem happens seems to also be the edge of where there's some laggy scrolling.  My eyes aren't good enough to be sure which side is lagging, though, but I *think* it's the right side of the line that's lagging.

So my guess would be that something related to the laggy scrolling is causing double-painting of things on the left side of the line whose frames also extend to the right of the line -- perhaps because we're failing to clip properly when trying to repaint only what's to the right of the line?
Comment 6 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2012-02-24 15:46:39 PST
Created attachment 600555 [details]
partially simplified testcase

Simplified from http://whatsup.org.il/index.php?name=PNphpBB2&file=viewtopic&t=57990
Comment 7 Yotam Benshalom 2012-02-24 15:47:21 PST
This happens here too, on ubuntu 11.10 64 bit, firefox 12.0a2 (2012-02-22). The hardware is Dell studio xps laptop with nvidia 9500m card, using proprietary driver. Please let me know if I can help with further information for diagnostics.
Comment 8 Dotan Porat 2012-02-24 16:02:55 PST
This happens here too, on mint 12, firefox 12.0a2 (2012-02-22). The hardware is Lenovo thinkpad t43p with ati graphic card with open source driver. thanks.
Comment 9 David Baron :dbaron: ⌚️UTC-7 (review requests must explain patch) 2012-02-24 16:08:07 PST
More "here too" reports are not helpful.
Comment 10 Timothy Nikkel (:tnikkel) 2012-02-24 20:19:23 PST
Created attachment 600612 [details]
more reduced testcase
Comment 11 Tomer Cohen :tomer 2012-03-01 00:43:51 PST
Created attachment 601897 [details]
WordPress RTL screenshot

I am able to reproduce this behavior on plain WordPress installation with default theme (twentyeleven), although it is less visible than on whatsup.org.il.

Steps to reproduce: place cursor inside the comments textarea and roll the mouse wheel up and down without leaving the keyboard focus from the textarea.
Comment 12 Tomer Cohen :tomer 2012-03-24 10:53:27 PDT
Created attachment 609018 [details]
another site screenshot

I was able to reproduce the same issue on other site as well. 
http://seodoityourself.co.il/?p=2864
Comment 13 Karl Tomlinson (:karlt) 2012-07-29 16:13:07 PDT
*** Bug 775203 has been marked as a duplicate of this bug. ***
Comment 14 Karl Tomlinson (:karlt) 2012-07-29 22:30:26 PDT
This code is assuming that extents on a cairo_clip_t->path are accurate when the clip region is a rectangle
http://mxr.mozilla.org/mozilla-central/source/gfx/cairo/cairo/src/cairo-xlib-surface.c#4816
But that is not the case when the clip path has a prev path.
The rectangle is the intersection of the paths.

(gdb) p clip_region->rgn.extents
$69 = {
  x1 = 8, 
  y1 = 137, 
  x2 = 291, 
  y2 = 238
}
(gdb) p *clip_extents
$70 = {
  x = 8, 
  y = 137, 
  width = 750, 
  height = 342
}
Comment 15 Karl Tomlinson (:karlt) 2012-07-30 16:16:21 PDT
Created attachment 647346 [details] [diff] [review]
use precise region extents instead of loose clip extents for clip rect
Comment 16 Karl Tomlinson (:karlt) 2012-07-31 18:59:56 PDT
Created attachment 647812 [details] [diff] [review]
reftest
Comment 17 Karl Tomlinson (:karlt) 2012-07-31 19:04:10 PDT
clip extents are the intersection of extents of each clip path applied.
Comment 20 Ed Morley [:emorley] 2012-08-17 05:27:17 PDT
https://hg.mozilla.org/mozilla-central/rev/95977d7f113d
Comment 21 :Ms2ger (⌚ UTC+1/+2) 2012-08-17 06:17:06 PDT
Karl, did you mean to disable 468496-1.html?
Comment 22 Jeff Muizelaar [:jrmuizel] 2012-08-17 12:53:16 PDT
Comment on attachment 647346 [details] [diff] [review]
use precise region extents instead of loose clip extents for clip rect

Review of attachment 647346 [details] [diff] [review]:
-----------------------------------------------------------------

Sorry this took so long.
Comment 23 Karl Tomlinson (:karlt) 2012-08-17 14:02:42 PDT
(In reply to :Ms2ger from comment #21)
> Karl, did you mean to disable 468496-1.html?

No I didn't sorry.  Thanks for catching that.

Restored in https://hg.mozilla.org/integration/mozilla-inbound/rev/5fb4e694c64d
Comment 24 Karl Tomlinson (:karlt) 2012-08-17 14:04:19 PDT
Fix for this bug pushed:
https://hg.mozilla.org/integration/mozilla-inbound/rev/8b3891772df8
Comment 26 :Ms2ger (⌚ UTC+1/+2) 2012-08-18 01:12:58 PDT
(In reply to Karl Tomlinson (:karlt) from comment #23)
> (In reply to :Ms2ger from comment #21)
> > Karl, did you mean to disable 468496-1.html?
> 
> No I didn't sorry.  Thanks for catching that.
> 
> Restored in
> https://hg.mozilla.org/integration/mozilla-inbound/rev/5fb4e694c64d

Thanks for fixing :)

Note You need to log in before you can comment on or make changes to this bug.